PROGRAM TurboPacket;
{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V+}
{$M 10000,240000,240000}

(* 7 Seiten / 9 Kanle : 360K *)
(* 5 Seiten / 9 Kanle : 280K *)
(* 4 Seiten / 9 Kanle : 240K *)
(* 3 Seiten / 9 Kanle : 200K *)
(* 2 Seiten / 9 Kanle : 160K *)

(*  Beim Compilieren wichtig: Range-check          off
                              Var-string checking  strikt
                              Boolean evaluation   short circuit  *)
(*  STACK,MIN,HEAP *)

(* MIN und HEAP mssen grundstzlich gleich gro sein.
   Durch maxlink werden je kanal 7181 - xss Byte bentigt ( xss negativ
   deshalb -xss), bei ass=2 (2 seiten zu scrollen) sind das
   7181 + 7680 = 14861 byte, HEAP bei 9 Kanlen: 160000 Byte
                             also bei 4 Kanlen: 160000-(5*15000)=85000 Byte
   nur dann (!) um Speicherplatz zu sparen korrigieren und
   CONFIG.SYS auf nur 4 Kanle begrenzen, d.h. die 5 Zeilen der restlichen
   Kanle entfernen (das sind nur Ungefhrangeben, bei RUNTIME-ERROR ggf.
   stufenweise erhhen)!
   ( z.B. 9 Kanle, 8 Seiten zum scrollen: 400K )
   SYSOP: Mit <ALT-O> <C> <C> (Conditional defines) "SYSOP" setzen, alle
   eventuell vorhandenen *.TPU Dateien lschen, und neu compilieren
   (auf DISK, nicht ins Memory)

   Option SP ( wie Spezial oder Simpel ): kein Maskenaufbau bei Prgbeginn.
   ACHTUNG: WENN MIT ANDEREN CONDITIONAL DEFINES NEU COMPELIERT WERDEN
   SOLL, ZUVOR ALLE *.TPU LSCHEN !!!


   TERMINAL - Programm fuer den HOSTMODE des TNC-1 oder TNC-2
   in Verbindung mit einem IBM-PC oder kompatiblen Rechner

   Reiner Schmidt, Arminiusstr. 11, 4550 Bramsche 8, Tel: 05461/1736
             oder: Friesenstr. 64, 3000 Hannover 1 (Studien-Adresse)

   Programm und Quelltexte sind ausdruecklich PUBLIC DOMAIN, koennen also
   an jeden interessierten Funkamateur zur NICHT-KOMMERZIELLEN NUTZUNG
   weitergegeben werden.

   Anmerkung von DG6MAY (@DB0PV) :zu compilieren mit TURBO-PASCAL 5.0

   Benoetigte Module:

      - PR.PAS         (Hauptprogramm)
      - PRDEFS.PAS     (Constanten-, Variablen- und Typdefinitionen)
      - PRLIB.PAS      (div. Routinen)
      - PRV24.PAS      (V24-InterruptRoutinen)
      - PRAUS.PAS      (Zeichenausgabe u. Seitenverwaltung)
      - PRLIB1.PAS     (div. Routinen)
      - PRLIB2.PAS     (TYpe-Funktion)
      - PRLIB3.PAS     (Enthlt die folgenden Module)
      - PRPASS.PAS     (Passwort-Routinen zur DK0MAV-Mailbox)
      - PR1.PAS        (Routinen zum Ansprechen des TNC im Hostmode)
      - PR2.PAS        (Routinen zum Ansprechen des TNC im Hostmode)
      - PRTAST.PAS     (Tastaturdekoder)

    Fuer den anschliessenden Programmlauf sind allerdings weitere Files
    erforderlich, bitte das File TURBOPR.DOC lesen !


    A C H T U N G :

      Dieses Programm ist ein reines Hobby-Produkt!
      Fr Fehler, insbesondere fr eventuelle Datenverluste, kann KEINERLEI
      HAFTUNG bernommen werden!

      *)


USES  Printer, Crt, Dos,
      PRDEFS, PRLIB, PRV24, PRAUS, PRLIB1, PRLIB2, PRLIB3;


BEGIN   (****  H A U P T P R O G R A M M  ****)

  setcbreak(false);                   (* kein Abbruch durch ctrl-C *)
  CheckSnow := false;
  TextAttrMerk := TextAttr;

  {$IFNDEF SP}  Maske;
  {$ELSE}       write(^M^J'Bitte warten, THP ldt ');
  {$ENDIF}

  FOR Kanal := 0 TO maxLink DO NEW(K[Kanal]);  (* Speicher auf Heap schaffen *)

  {$IFDEF SYSOP} randomize; {$ENDIF}

  Var_INIT;

  SysPfad := Getenv('PRSYS');
  if (syspfad <> '') and (syspfad[length(syspfad)] <> '\') then
      syspfad:=syspfad+'\';
  shell   := Getenv('COMSPEC');

  assign(LogFile,     SysPfad+'PACK.LOG'   );   (* LogFile *)
  assign(MFile,       SysPfad+'MERKER.TXT' );   (* Merker-File *)
  assign(AFile,       SysPfad+'ATTRIB.TXT' );   (* Attribut-File *)
  assign(msgfile,     SysPfad+'PR.MSG'     );   (* MSG-FILE *)
  assign(Config,      SysPfad+'CONFIG'+parmstr+'.PR');   (* Config-File *)
  assign(cmdFile,     SysPfad+'PR'+parmstr+'.CMD');   (* Init-, Start- und Stopkommandos *)
  assign(NRPWFile,    SysPfad+'NETROM.PWF' );

  ConfigLesen;  if Uebergabe('LCD') then VideoCard := '4';
  MerkerFile_Lesen;
  setV24(BaudRate);   (* Baudrate, 8Data, 1Stop, no Parity *)
  AttributFile_Lesen;
  msgFile_lesen;  (* Festspeichertexte einlesen *)

  MB_1;
  Cursor_aus;
  PageInit;

  show := 0;

  for Kanal := 0 to maxLink do
  Begin
    with K[Kanal]^ do
    Begin
      merkinput:='';
      assign(RXFile,Save_Name);
      SetTextBuf(RXFile,RXFileBuffer);
      TextAttr := neg;
      writePage(Kanal,1,3,ConstStr(#32,80));
      IF (Kanal <> 0) THEN StatusOut(Kanal,2,hell,char(48+Kanal));
      if (connected OR save_m) and poll then
      (* ist beim aufruf von pr ein kanal con. zur sicherheit saven,
         denn die msg kann mehr als monitor sein ! *)
      Begin
        Save := true;
        OpenSaveFile(Kanal);
        StatusOut(Kanal,15,hell,saven(kanal));
        if connected then StatusOut(Kanal,4,hell,Call);
      End;
      if Auto and (Kanal <> 0) then StatusOut(Kanal,66,hell,'A');
      if Klingel and (Kanal = 0) then StatusOut(0,70,hell,'K');
      if Umlaut then StatusOut(Kanal,68,hell,'U');
      if (Kanal = 0) and Time_stamp then StatusOut(0,66,hell,'T');
      Cursor(Kanal);
    End; (* with K[Kanal]^ do ... *)
  End;

  TextAttr := low;

  gotoxy(1,5);
  TNC_Anzahl := 0;
  for i := 1 to maxtnc do
  Begin                (* alle angeschlossenen TNCs in den Hostmode schalten *)
    if Schnitte[i].TNC then
    Begin
      Inc(TNC_Anzahl);
      write('TNC an RS232-',i);
      switch_V24(i);
      writeaux(^X^X + cmd_char + 'E0' + #13);
      writeaux(cmd_char + 'MN' + #13);
      writeaux(cmd_char + 'JHOST1' + #13);
      Delay(150);    (* ca. 1 Sekunde warten *)
      WHILE Zeichen DO readaux(ch_in);
      writeln(' ist im Hostmode');
    End;
  End;

  Datum := Date;
  Zeit := Time;

  Std10Merker := Zeit[1];
  Std1Merker  := Zeit[2];
  Min10Merker := Zeit[4];
  Min1Merker  := Zeit[5];
  Sec10Merker := Zeit[7];
  Sec1Merker  := Zeit[8];

  for i := 1 to TNC_Anzahl do    (* Uhr in jedem TNC stellen, falls mglich *)
  Begin
    poll_Moni := i;
    Ausgabe := FALSE;  (* ev. Fehlerausgabe unterdruecken *)
    S_Com(0,'K' + copy(Datum,4,8));
    if K[0]^.Response = 'ok' then BEGIN
      (* TNC hat V2.1c, also Uhr stellen und ev. einschalten (K1) *)
      S_Com(0,'K' + Zeit);
      Ausgabe := FALSE;
      S_Com(0,'K');
      IF K[0]^.Response[1] = '0' THEN S_Com(0,'K1');  (* Uhr einschalten *)
    END;
  end;

  multiTNC := (TNC_Anzahl > 1);
  StatusOut(0,36,dunkel,V1_str+'/'+update);

  (* cmdFile ist schon offen *)
  repeat
    readln(cmdFile,Zeile);
  until copy(Zeile,1,1) = '<';                 (* nicht zeile[..] hier ! *)

  if Uebergabe('INIT') then
  Begin
    writeln('TNC-INIT');
    readln(cmdFile,Zeile);
    while copy(Zeile,1,1) <> '<' do            (* nicht zeile[..] hier ! *)
    Begin
      if length(Zeile) > 0 then
      Begin
        i := ord(Zeile[1]) - 48;
        if Schnitte[i].TNC then
        Begin
          Convert_ctrl_O_ctrl_M(Zeile);
          delete(Zeile,1,2);
          poll_Moni := i;
          S_Com(0,Zeile);
        End;
       End;
      readln(cmdFile,Zeile);
    End;
  End
  else
  Begin
    repeat
      readln(cmdFile,Zeile);
    until copy(Zeile,1,1) = '<';                 (* nicht zeile[..] hier ! *)
  End;

  readln(cmdFile,Zeile);
  while copy(Zeile,1,1) <> '<' do                (* nicht zeile[..] hier ! *)
  Begin
    if length(Zeile) > 0 then
    Begin
      i := ord(Zeile[1]) - 48;
      if Schnitte[i].TNC then
      Begin
        delete(Zeile,1,2);
        Convert_ctrl_O_ctrl_M(Zeile);
        poll_Moni := i;
        S_Com(0,Zeile);
      End;
    End;
    readln(cmdFile,Zeile);
  End;

  poll_Moni := 1;
  while (not Schnitte[poll_Moni].TNC) do inc(poll_Moni);
  unproto := poll_Moni;
  StatusOut(0,2,1,Channel_ID(0));


  for i := 1 to TNC_Anzahl do             (* ermittle das Call aus TNC *)
  Begin
    poll_Moni := i;
    ausgabe:=false;
    S_Com(0,'I');
    HostCall := (copy(K[0]^.Response,1,9));
    M_aus(inf+'Call TNC '+schnitte[i].ident+' ist '+hostcall+^M);
    i1:=pos('-',hostcall);
    if i1=0 then i1:=pos(^M,hostcall);
    if i1 > 0 then hostcall:=copy(hostcall,1,i1-1);
    ausgabe:=true;
  end;


  i := 1;
  while not K[i]^.poll do inc(i);
  show := i;
  K[i]^.NochNichtGelesen := false;
  Neu_Bild;                            (* ersten pollKanal einschalten *)


  repeat  (****  H A U P T S C H L E I F E  ****)
   poll_Tastatur;
   PollTNC;
   Uhr_aus;
  until QRT;   (*  E N D E  der  H A U P T S C H L E I F E  *)

  clrscr;
  gotoxy(1,3);
  Writeln('TP wird beendet! Bitte warten ...');

  (* Stopkommandos an die TNCs senden *)

  uterr:='';
  repeat
    readln(cmdFile,Zeile);
    if length(Zeile) > 0 then
    Begin
      i := ord(Zeile[1]) - 48;
      if Schnitte[i].TNC then
      Begin
        delete(Zeile,1,2);
        i1:=pos('UT',zeile); {gro schreiben nur !}
        if i1=1 then
          begin
            delete(zeile,2,1);
            if length(zeile)>68 then
                 uterr:='UT-Text zu lang, max 68 Zeichen!'+
                        ' Text wurde ohne Datum/Zeit gespeichert!'
            else zeile:=zeile+' ('+copy(date,7,2)+copy(date,4,2)
                        +copy(time,1,2)+copy(time,4,2)+')';
          end;
        Convert_ctrl_O_ctrl_M(Zeile);
        poll_Moni := i;
        S_Com(0,Zeile);
      End;
    End;
  until eof(cmdFile);
  close(cmdFile);

  for i := 1 to maxtnc do
  Begin
    if Schnitte[i].TNC then
    Begin
      poll_Moni := i;
      S_com(0,'MN');
      S_Com(0,'E1');
      S_Com(0,'JHOST0');     (* Hostmode verlassen *)
      delay(150);
      while Zeichen do readaux(ch_in);
    End;
  End;

  V24_Close;    (* InterruptVektoren zurckstellen *)

  gesMin := gesMin + LaufZeit;
  gesStd := gesStd + gesMin div 60;
  gesMin := gesMin mod 60;

  {$I-} Reset(MFile); {$I+}
  IF IOResult = 0 THEN BEGIN
    (* Merkerfile nur neu schreiben, wenn es auch wirklich existiert *)
    Close(MFile);
    Rewrite(MFile);
    writeln(MFile,'.');
    for Kanal := 1 to maxLink do
    Begin
      if K[Kanal]^.connected then
      Begin
        with K[Kanal]^ do
        Begin
          writeln(MFile,Call);
          writeln(MFile,qsoDatum);
          writeln(MFile,qsoBeginn);
          writeln(MFile,ConText);
        End;
      End
      else
      Begin
        writeln(MFile,'(',char(Kanal+48),') disconnected');
        writeln(MFile,'.');
        writeln(MFile,'.');
        writeln(MFile,'.');
      End;
    End;
    for Kanal := 0 to maxLink do
    Begin
      with K[Kanal]^ do
      Begin
        write(MFile,PacLen,' ');
        if Umlaut then write(MFile,'U');
        if Auto then write(MFile,'A');
        if Save then write(MFile,'S');
        if Kanal = 0 then
        Begin
          if Klingel then write(MFile,'K');
          if Time_stamp then write(MFile,'T');
          WRITE(MFile,'Z:',K[1]^.Trenn);
        End;
        IF Save THEN WRITE(MFile,' @',Save_Name);
        writeln(MFile);
      End;
    End;
    writeln(MFile,Resync_Z);
    writeln(MFile,gesStd);
    writeln(MFile,gesMin);
    writeln(MFile,'----- End of MerkerFile -----');
    close(MFile);
  END;

  for Kanal := 0 to maxLink do
  Begin
    if K[Kanal]^.Save then
    Begin
      close(K[Kanal]^.RXFile);
      K[Kanal]^.Save := false;
    End;
  End;

  Cursor_ein; gotoxy(1,3);
  if uterr<>'' then begin textattr:=norm; writeln(#7,#7,uterr); end;

  TextAttr := norm;
  WRITELN('Ende TurboPacket  ',Date,'  ',Time);
  TextAttr := low;

  writeln(V1_str,' aktiv fr ',int_str(laufzeit),' Minuten.',^M^J,
          'Gesamt-Programmlaufzeit  ',int_str(gesstd),' Stunden, ',
          int_str(gesmin),' Minuten.');

  TextAttr := TextAttrMerk;
End.
